// Copyright 2023 Georges Racinet <georges.racinet@octobus.net>
//
// This software may be used and distributed according to the terms of the
// GNU General Public License version 2 or any later version.
// SPDX-License-Identifier: GPL-2.0-or-later
#[macro_use]
extern crate build_const;

// The generated module is derived from the Protobuf "package" name
// Hence as soon as we start compiling the HGitaly-specific proto files,
// we'll also get a `hgitaly` module.
// using `include!` lets us add attributes, in this case to control clippy
pub mod gitaly {
    #![allow(unknown_lints)]
    include! {"generated/gitaly.rs"}
}

pub mod config;
pub mod message;
pub mod repository;
pub mod service;
pub mod streaming;

pub use config::*;
pub use gitaly::*;
